<?php
// Подключаем класс для работы с БД
require_once("Db.php");

/**
 * Class Auth
 */
class Auth extends Db
{
    // токен API BOT
    private $token = "___TOKEN__ВАШЕГО__БОТА___";

    /** Инициализируем работу класса
     * @return bool
     */
    public function init()
    {
        // получаем данные от АПИ и преобразуем их в ассоциативный массив
        $rawData = json_decode(file_get_contents('php://input'), true);
        // направляем данные из бота в метод
        // для определения дальнейшего выбора действий
        $this->router($rawData);
        // в любом случае вернем true для бот апи
        return true;
    }

    /** Роутер
     * @param $data array
     * @return bool
     */
    private function router($data)
    {
        // проверяем на объект Message
        if (array_key_exists("message", $data)) {
            // получаем чат
            $chat_id = $data['message']['chat']['id'];
            // проверяем на наличие объекта Text
            if (array_key_exists("text", $data['message'])) {
                // Получаем значение отправленных данных
                $text = $data['message']['text'];
                // Если это просто старт бота
                if ($text == "/start") {
                    // отправляем сообщение
                    $this->botApiQuery("sendMessage", [
                        'chat_id' => $chat_id,
                        'text' => 'Бот авторизации'
                    ]);
                    // Если это старт бота с передаваемым значением параметра start    
                } elseif (preg_match('~^(\/start)+ ([a-f0-9]{32}+)$~', $text, $matches)) {
                    // передаем в метод авторизации
                    $this->setAuth($data['message'], $matches[2]);
                    // если это какой-то другой текст   
                } else {
                    // просто пишем чего-нибудь в чат
                    $this->botApiQuery("sendMessage", [
                        'chat_id' => $chat_id,
                        'text' => 'Бот авторизации'
                    ]);
                }
                // если это что-то другое - картинка или еще что-то    
            } else {
                // просто пишем чего-нибудь в чат
                $this->botApiQuery("sendMessage", [
                    'chat_id' => $chat_id,
                    'text' => 'Бот авторизации'
                ]);
            }
        }
        // другие объекты не рассматриваем 
        return true;
    }

    /** Авторизация
     * @param $data
     * @param $key
     */
    private function setAuth($data, $key)
    {
        // делаем запрос в БД
        $order = $this->connect()->prepare("SELECT * FROM users WHERE telegram_id = :id LIMIT 1");
        $order->execute(['id' => $data['chat']['id']]);
        // если запись есть то обновляем
        if ($order->rowCount() > 0) {
            $orderRaw = $order->fetch();
            // запрос на обновление
            $update = $this->connect()->prepare("UPDATE users SET auth_key = :new_key WHERE id = :id");
            // если обновили
            if ($update->execute(['id' => $orderRaw['id'], 'new_key' => $key])) {
                $text = "Вы успешно авторизовались. Возвращайтесь на сайт.";
            } else {
                $text = "При авторизации произошла ошибка";
            }
        } else {
            // если записи нет то добавляем
            $insert = $this->connect()->prepare("INSERT INTO users SET
                telegram_id = :telegram_id,
                first_name = :first_name, 
                last_name = :last_name, 
                username = :username, 
                auth_key = :auth_key");
            // готовим данные
            $array = [
                'telegram_id' => $data['chat']['id'],
                'first_name' => $data['chat']['first_name'],
                'last_name' => $data['chat']['last_name'],
                'username' => $data['chat']['username'],
                'auth_key' => $key,
            ];
            // если удалось добавить товар
            if ($insert->execute($array)) {
                $text = "Вы успешно авторизовались. Возвращайтесь на сайт.";
            } else {
                $text = "При авторизации произошла ошибка";
            }
        }
        // отправляем сообщение
        $this->botApiQuery("sendMessage", [
            'chat_id' => $data['chat']['id'],
            'text' => $text
        ]);
    }

    /** Работаем с API BOT
     * @param $method
     * @param array $fields
     * @return mixed
     */
    private function botApiQuery($method, $fields = array())
    {
        $ch = curl_init('https://api.telegram.org/bot' . $this->token . '/' . $method);
        curl_setopt_array($ch, array(
            CURLOPT_POST => count($fields),
            CURLOPT_POSTFIELDS => http_build_query($fields),
            CURLOPT_SSL_VERIFYPEER => 0,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_TIMEOUT => 10
        ));
        $r = json_decode(curl_exec($ch), true);
        curl_close($ch);
        return $r;
    }
}
?>